<?php
/*
Plugin Name: Search Pages Generator
Plugin Script: spgen.php
Plugin URI: http://worldiclub.com/spgen.html
Description: Search Pages Generator это плагин который позволяет автоматически увеличивать количество страниц вашего блога на Wordpress за счет добавления ссылок на страницы с результатами встроенного поиска Wordpress. Ссылки создаются автоматически путем разбиения заголовка поста (или другого текста) на отдельные слова и формирования URL страниц поиска по этим словам. Таким образом если заголовок поста содержит четыре слова, то для него плагин сформирует блок из четырех ссылок на результаты поиска по этим словам. Пример: Заголовок поста - "Первый пост на этом блоге", будут сформированы ссылки на следующие страницы поиска: ?s=Первый ?s=пост ?s=этом ?s=блоге.
Version: 0.2
License: GPL
Author: Evgeniy Konstantinov
Author URI: http://worldiclub.com
*/





function spgen_options_page() 
{
	if($_POST['spgen_save_options']) 
	{
		update_option('spgen_htmlbefore', $_POST['spgen_htmlbefore']);
		update_option('spgen_htmlafter', $_POST['spgen_htmlafter']);
		echo '<div class="updated"><p>Настройки SPGen обновлены.</p></div>';
	}
	
	$htmlbefore = get_option('spgen_htmlbefore');
	$htmlafter = get_option('spgen_htmlafter');

?>
<div class="wrap">
	<h2>Настройки Search Pages Generator</h2>

	<form method="post">
	<fieldset class="options">
	
	<input type="hidden" value="save" id="spgen_save_options" name="spgen_save_options" />
	
	<label for="spgen_htmlbefore" style="line-height:35px;display:block;">
	<b>HTML код</b> который будет выведен <b>перед блоком сформированных ссылок</b>:<br />
	<input type="text" value="<?php echo $htmlbefore; ?>" id="spgen_htmlbefore" name="spgen_htmlbefore" style="width: 400px;"/>
	</label>

	<label for="spgen_htmlafter" style="line-height:35px;display:block;">
	<b>HTML код</b> который будет выведен <b>после блока сформированных ссылок</b>:<br />
	<input type="text" value="<?php echo $htmlafter; ?>" id="spgen_htmlafter" name="spgen_htmlafter" style="width: 400px;"/>
	</label>
	<br /><br />
	<input type="submit" value="Сохранить" />

	</fieldset>
	</form>
</div>
<?php
}


function spgen_add_menu()
{
	add_options_page('SPGen', 'SPGen', 8, __FILE__, 'spgen_options_page');
}




function spgen_filter($content) 
{

	$htmlbefore = get_option('spgen_htmlbefore');
	$htmlafter = get_option('spgen_htmlafter');

	$post_title = the_title('','',false);

	$words = split('[\.|,|\:|\?|!|;|-| ]', strip_tags($post_title));

	$stres = '';

	foreach($words as $key=>$value)
	{
		if (strlen($value) > 3)
		{
			$stres .= '<a href="'.get_bloginfo('url').'/?s='.$value.'" title="'.$value.'" >'.$value.'</a> ';
		}
	}
	
	$spgen_html = $htmlbefore.$stres.$htmlafter;

	$content = $content . $spgen_html ;
	
	return $content;
}
add_action('admin_menu', 'spgen_add_menu');

add_filter('the_content', 'spgen_filter');

?>